import Vue from 'vue'

import Cookies from 'js-cookie'

import Element from 'element-ui'
import AFTableColumn from 'af-table-column'
import './assets/fonts/iconfont.css'
import './assets/styles/element-variables.scss'

import '@/assets/styles/index.scss' // global css
import '@/assets/styles/ruoyi.scss' // ruoyi css
import App from './App'
import store from './store'
import api from '@/api/api'
import gsap from 'gsap'
import upload from '@/utils/uploadFile'
import router from './router'
import directive from './directive' //directive
import plugins from './plugins' // plugins
import './assets/icons' // icon
import './permission' // permission control
import { parseTime, resetForm, addDateRange, selectDictLabel, selectDictLabels, handleTree } from "@/utils/ruoyi";
// 通用弹窗
import BaseDialog from "@/components/BaseDialog";
// 分页组件
import Pagination from "@/components/Paginations";
// 自定义表格工具组件
import RightToolbar from "@/components/RightToolbar"
// 文件上传组件
import FileUpload from "@/components/FileUpload"
// 字典标签组件
import DictTag from '@/components/DictTag'
import methodsTools from '@/utils/methodsTool'
// 全局方法挂载

Vue.prototype.$store = store
Vue.prototype.parseTime = parseTime
Vue.prototype.resetForm = resetForm
Vue.prototype.addDateRange = addDateRange
Vue.prototype.selectDictLabel = selectDictLabel
Vue.prototype.selectDictLabels = selectDictLabels
Vue.prototype.handleTree = handleTree
Vue.prototype.$api = api
Vue.prototype.$upload = upload
Vue.prototype.$methodsTools = methodsTools
Vue.prototype.gsap = gsap

// 全局组件挂载
Vue.component('DictTag', DictTag)
Vue.component('Pagination', Pagination)
Vue.component('BaseDialog', BaseDialog)
Vue.component('RightToolbar', RightToolbar)
Vue.component('FileUpload', FileUpload)
const fontRate = {
  CHAR_RATE: 1.1, // 汉字比率
  NUM_RATE: 0.65, // 数字
  OTHER_RATE: 0.8 // 除汉字和数字以外的字符的比率
}
const fontSize = 16
// 注册组件
Vue.use(AFTableColumn, { fontRate, fontSize })
Vue.use(directive)
Vue.use(plugins)

/**
 * If you don't want to use mock-server
 * you want to use MockJs for mock api
 * you can execute: mockXHR()
 *
 * Currently MockJs will be used in the production environment,
 * please remove it before going online! ! !
 */

Vue.use(Element, {
  size: Cookies.get('size') || 'medium' // set element-ui default size
})

Vue.config.productionTip = false

new Vue({
  el: '#app',
  router,
  store,
  render: h => h(App)
})
